/*
Siemens XML Parser 1.0 (Validating)
Example to show use of XML Parser library by reading a PMML Based XML File
Date: 15 July 2008
Written by: Danish Chopra

usage: XMLObject.getChildNode(index).getChildNode(index).getChildNode(index).getChildNode(index) ...upto 'n' hierarchy level

getChildNode has different functions at its disposal such as
.getAttributeName, .getName, .getText, .getVersion, .nChildNodes for counting the number of child nodes etc..

PMML Header goes as follows:

<?xml version="1.0" encoding="ISO-8859-1" ?> 
<PMML version="3.0" xmlns="http://www.dmg.org/PMML-3-0" xmlns:xsi="http://www.w3.org/2001/XMLSchema_instance">
*******************body*********************
</PMML>
*/
#include <stdio.h>
#include<iostream.h>
#include "xmlParser.h"
void myfree(char *t); /*To free the memory*/
ToXMLStringTool tx,tx2;

/*Function prototypes*/
void select(); 
void MakePMML();
char nodename[40];
char xmldoc[40];

XMLNode xMainNode; //Our XML Object

int num=0;
char stuff[300];


void trim(char **ppstr){
   char *p = *ppstr;
   while( p && *p != '\0' )
   {
    if ( *p == 10 || *p == 13 || *p == ' ')
    p++;
    else
    break;
   }
   *ppstr = p;
}



int main(int argc, char **argv)
{
int i=0;
printf("Welcome to XML Parser 1.0 \n");
printf("Please enter the XML or PMML-XML Filename \n");
//scanf("%s",xmldoc);
strcpy(xmldoc,"dict_sokrat_enru_ansi.xdxf");

cout<<endl;
printf("%s","Generating Tree view of the XML document: ");
printf(xmldoc);
// xMainNode=XMLNode::openFileHelper (xmldoc,"PMML");  // If not sure of format leave the 2nd argument blank- ""
xMainNode=XMLNode::openFileHelper (xmldoc,"");  // If not sure of format leave the 2nd argument blank- ""
XMLNode xNode=xMainNode.getChildNode("xdxf");//read header node if any?
cout<<endl;    
printf("Text inside Header tag(if any) is :'%s'\n", xNode.getText());
cout<<endl;

printf("Text inside 'ar' is :'%s'\n", xNode.getChildNode("ar").getText());
printf("Text inside 'k' is :'%s'\n", xNode.getChildNode("ar").getChildNode("k").getText());

printf("xNode.getChildNode(<ar>).getName() :'%s'\n", xNode.getChildNode("ar").getName() );

cout<<endl;
int n=xMainNode.getChildNode(xMainNode.getChildNode(0).getName()).nChildNode();
printf("Number of child nodes found '%d' \n",n); //Number of child nodes
printf("%s \n",xMainNode.getChildNode(0).getName());
/*
for (i=2; i<n; i++)  //Print information
{
cout<<endl;
printf("(%d) ",i);
cout<<endl;
printf("%s",xMainNode.getChildNode(0).getChildNode(i).getChildNode("k").getText());
cout<<endl;
printf("%s",xMainNode.getChildNode(0).getChildNode(i).getText());

}
*/
/*
FILE *fp;
char xmldoc[300] = "plaindict.txt";
fp = fopen(xmldoc,"a");
fseek (fp, 0 , SEEK_SET );
rewind(fp);
for (i=2; i<n; i++)  //Print information
{
 fprintf(fp,"%s\n%s\n", xMainNode.getChildNode(0).getChildNode(i).getChildNode("k").getText(), 
 xMainNode.getChildNode(0).getChildNode(i).getText());
}
fclose(fp);
*/
FILE *fp_key;
FILE *fp_art;
FILE *fp_log;

#define FOLDER_DICT_OUT "dict_socrat\\"
#define EXT_KEY_FILE ".key"
#define EXT_ARTICLE_FILE ".art"

char logfile[256];
strcpy( logfile, FOLDER_DICT_OUT);
strcat( logfile, "log.txt" );

char keywordfile[256];
strcpy( keywordfile, FOLDER_DICT_OUT);
strcat( keywordfile, "a" );
strcat( keywordfile, EXT_KEY_FILE );

char articlefile[256];
strcpy( articlefile, FOLDER_DICT_OUT);
strcat( articlefile, "a" );
strcat( articlefile, EXT_ARTICLE_FILE );

fp_key = fopen(keywordfile,"wb");
fseek (fp_key, 0 , SEEK_SET );

fp_art = fopen(articlefile,"wb");
fseek (fp_art, 0 , SEEK_SET );

fp_log = fopen(logfile,"w");
fseek (fp_log, 0 , SEEK_SET );

int offset_article = 0;
int len_article = 0;
int len_key = 0;
int max_len_article = 0;
int max_len_key = 0;
//!!int cnt_key_ = 0;
int global_max_len_key = 0;
int global_max_len_article = 0;

#define KEY_WORD_LEN 63

char *first_symb = (char *)xMainNode.getChildNode(0).getChildNode(2).getChildNode("k").getText(); // 'a'
char *symb = 0;

for (i=2; i<n; i++)  //Print information
{
 symb = (char *)xMainNode.getChildNode(0).getChildNode(i).getChildNode("k").getText();
// if( *first_symb != *symb ) 
 {

 fprintf(fp_log, "\n %c : max_len_key=%d : max_len_article=%d\n", *first_symb, max_len_key, max_len_article);

 *first_symb = *symb;
 offset_article = 0;
 max_len_article = 0;
 max_len_key = 0;
 //strncpy(keywordfile, symb, 1 );
 strcpy( keywordfile, FOLDER_DICT_OUT);
 strncat( keywordfile, symb, 1 );
 strcat( keywordfile, EXT_KEY_FILE );

 strcpy( articlefile, FOLDER_DICT_OUT);
 strncat( articlefile, symb, 1 );
 strcat( articlefile, EXT_ARTICLE_FILE );

/* fclose(fp_key);
 fclose(fp_art);

 fp_key = fopen(keywordfile,"w");
 fseek (fp_key, 0 , SEEK_SET );

 fp_art = fopen(articlefile,"w");
 fseek (fp_art, 0 , SEEK_SET );
*/
 }
 char *key_str = (char*)xMainNode.getChildNode(0).getChildNode(i).getChildNode("k").getText();
 trim(&key_str);
 char str[KEY_WORD_LEN+1]; // for {ENTER}
 int l = strlen(key_str);
 memset (str,'-',KEY_WORD_LEN);
 str[KEY_WORD_LEN] = 0;
 strcpy(str, key_str);
 if( l < KEY_WORD_LEN )
    str[l] = '-';

 //len_key = strlen( key_str );
 //fprintf(fp_key, "%s\r", key_str);
 len_key = strlen( str );
 fprintf(fp_key, "%s\r", str);

 int count = 0;
 char chnull = 0;
 // count = fwrite ((void*)&chnull, sizeof (char), 1, fp_key);
 // count = fwrite ((void*)&offset_article, sizeof (int), 1, fp_key);
 // count = fwrite ((void*)&len_article, sizeof (int), 1, fp_key);

 //if( i == 2594 ) <ar>an<ar> bugfix?
 // count = 0;
#define ARTICLE_LEN		128-1
 char  article[ARTICLE_LEN];
 memset (article,'-',ARTICLE_LEN);

 char *article_str = (char*) xMainNode.getChildNode(0).getChildNode(i).getText();
 // first line delete because it is key world
 char *p = strchr( article_str, '\n');
 //char *p = article_str;
 trim(&p);
 if(!p)
	p=article_str;	/// bug fix 'an'
 strcpy(article, p);
 article[ARTICLE_LEN-1] = 0;
 l = strlen(article);
 if( l < ARTICLE_LEN-1 )
     article[l] = '-';
 int len_temp=0;
 len_temp = strlen(article);

 // fprintf(fp_art,"%s", article );
 count = fwrite ((void*)article, ARTICLE_LEN, 1, fp_art);
 chnull = '\13';
 count = fwrite ((void*)&chnull, sizeof (char), 1, fp_art);
 
 /*if( p )
 fprintf(fp_art,"%s\r", p );
 else
 fprintf(fp_art,"%s\r", article_str );
 */
 len_article = strlen(article_str);
 offset_article += len_article;

 if(len_article > max_len_article)
 max_len_article = len_article;
 if(len_key> max_len_key)
 max_len_key = len_key;
 
 if(max_len_key > global_max_len_key)
 global_max_len_key = max_len_key;
 if(max_len_article > global_max_len_article)
 global_max_len_article = max_len_article;

}


fprintf(fp_log, "\n %c : max_len_key=%d : max_len_article=%d\n", *symb, max_len_key, max_len_article);
fprintf(fp_log, "\n\n global_max_len_key=%d : global_max_len_article=%d\n", global_max_len_key, global_max_len_article);

fclose(fp_key);
fclose(fp_art);
fclose(fp_log);

return 0;
}

void myfree(char *t){free(t);}  //Free memory used by our XML File

